<?php

//settings
$LEFT_BORDER=50;
$RIGHT_BORDER=100;
$UPPER_BORDER=10;
$LOWER_BORDER=40;
$BAR_WIDTH=15;
$SIZE_X=580;
$SIZE_Y=320;

$FONT_SCALE['size']=1;
$FONT_LEGEND['size']=2;

$FONT_FACE="/data/www/www.jochen-franke.de/efl-tracker/dev/system/fonts/arial.ttf";



//Bibliotheken nachladen
include("graph_functions.inc.php");

//Parameter auslesen...
foreach($_GET as $key => $value){

 if(substr($key,0,1)=="v"){
 $total[]=$value;
 }
 if(substr($key,0,1)=="s"){
 $scale[]=$value;
 }
 if(substr($key,0,2)=="mw"){
 $meanscale[]=$value;
 }
 if(substr($key,0,1)=="b"){
 $branche[]=$value;
 }
 if(substr($key,0,1)=="a"){
 $sbj_answer=$value;
 }
 if(substr($key,0,2)=="rt"){
 $sbj_answer_text=$value;
 }
 if(substr($key,0,2)=="nt"){
 $n_total=$value;
 }
 if(substr($key,0,2)=="nb"){
 $n_branche=$value;
 }

}

//Anzahl der Kategorien ermitteln, Breite der einzelnen Bereiche ermitteln
$num_category = count($total);

$spacing=($SIZE_X-$LEFT_BORDER-$RIGHT_BORDER)/($num_category);

//Maximale Skalenbeschriftung ermitteln und unteren Rand festlegen
 //Maximale String-Lnge ermitteln
 $max_value=0;
 $max_string="";
 foreach($scale as $skey => $svalue){
   if(strlen($svalue)>$max_length){
   	 $max_string=$svalue;
   	 $max_length=strlen($svalue);
   }
 }
  $max_chars=floor($spacing/imagefontwidth($FONT_SCALE['size']));
  $dummy_text=wordwrap($max_string,$max_chars);
 //Anzahl der Zeilen:
 $rows=count(split("\n",$dummy_text));
 
header ("Content-type: image/png");
$im = @imagecreate ($SIZE_X, $SIZE_Y)
    or die ("Cannot Initialize new GD image stream");
    


//Farben instanzieren
$WHITE = imagecolorallocate ($im, 255, 255, 255);
$BLACK = imagecolorallocate ($im, 0, 0, 0);
$BAR_COLOR_TOTAL = imagecolorallocate ($im, 128, 0, 0);
$BAR_COLOR_BRANCHE = imagecolorallocate ($im, 255, 153, 0);
$BAR_COLOR_ANSWER = imagecolorallocate ($im, 235, 235, 235);

$background_color=$WHITE;
$TEXT_COLOR=$BLACK;

$SKALA['color']=$BLACK;
$SKALA['size']=8;
$SKALA['font']=$FONT_FACE;

$ANSWER['color']=$BLACK;
$ANSWER['size']=8;
$ANSWER['font']="/data/www/www.jochen-franke.de/efl-tracker/dev/system/fonts/arialbd.ttf";

$LABELS['color']=$BLACK;
$LABELS['size']=8;
$LABELS['font']=$FONT_FACE;

$LEGEND['color']=$BLACK;
$LEGEND['size']=9;
$LEGEND['font']=$FONT_FACE;

$INFOSMALL['color']=$BLACK;
$INFOSMALL['size']=7;
$INFOSMALL['font']=$FONT_FACE;

   $font_metrics=imagettfbbox($LABELS['size'],0,$LABELS['font'],"X");
   $font_height=abs($font_metrics[7]);
   $font_width=abs($font_metrics[2]);
   
  $font_metrics2=imagettfbbox($ANSWER['size'],0,$ANSWER['font'],"n");
  $max_chars=floor(($SIZE_X-$RIGHT_BORDER)/abs($font_metrics2[2]));
  $dummy_text=wordwrap($sbj_answer_text,$max_chars);
 //Anzahl der Zeilen:
 $rows2=count(split("\n",$dummy_text));
 
 $UPPER_BORDER=10+($rows2+1)*abs($font_metrics2[7]);
 $LOWER_BORDER=10+$rows*$font_height;

//Skalierung zeichnen
 //Maximalen Wert ermitteln
 $max_value=0;
 foreach($total as $key => $value){
   if($value>$max_value) $max_value=$value;
 }
  foreach($branche as $key => $value){
   if($value>$max_value) $max_value=$value;
 }
 
 //Display-Hhe ermitteln
 $disp_height=$SIZE_Y-$UPPER_BORDER-$LOWER_BORDER;
 
 //Schrittweite ermitteln
  
 if($_GET['st']=="prz"){
 //Prozentskalierung, Maximum ist 100%
 if($max_value%10<5){
   $steps_y=(($max_value-($max_value%10))/10)+2;
 }else{
   $steps_y=(($max_value-($max_value%10))/10)+3;
 }

   $stepping_y=floor($disp_height/$steps_y);
   $scale_height=($steps_y-1)*$stepping_y;
   $scale_sign="%";
   $scale_max=($steps_y-1)*10;
 }
 //DEBUG
 //imagestring($im,1,100,20, "\$i: " . $steps_y, $text_color);

//Ab hier Zeichenfunktionen
//Antwort zeichnen falls vorhanden


if($sbj_answer!=-1){
drawAnswer($im,$sbj_answer,$BAR_COLOR_ANSWER);	
}

//Legende zeichnen
drawLegend($im,$BLACK,$BAR_COLOR_TOTAL,$BAR_COLOR_BRANCHE,$BAR_COLOR_ANSWER,$LEGEND);
drawAnswerText($im,$sbj_answer_text,$ANSWER);

 //Skala zeichnen
 for($k=0;$k<$steps_y;$k++){
  //$font_height=imagefontheight(2);
  $font_metrics=imagettfbbox(10,0,$FONT_FACE,"TEST");
  $font_height=abs($font_metrics[7]);
  $pos_y=$SIZE_Y-$LOWER_BORDER-$k*$stepping_y+$font_height/2;
  
 // imagettftext($im,10,0,10,20, $SKALA_COLOR,$FONT_FACE,"Font height: " . $font_height);
  
  
  imagettftext($im,$SKALA['size'],0,15,$pos_y, $SKALA['color'],$SKALA['font'],$k*10 . " %");
  drawHrzDotLine($im, $LEFT_BORDER, $SIZE_X-$RIGHT_BORDER, $SIZE_Y-$LOWER_BORDER-$k*$stepping_y, $BLACK); 
 }

drawMean($im,$total,$meanscale,$BAR_COLOR_TOTAL);

drawMean($im,$branche,$meanscale,$BAR_COLOR_BRANCHE);

drawBars($im,$total,$scale,$BAR_COLOR_TOTAL,0,2,$LABELS);

drawBars($im,$branche,$scale,$BAR_COLOR_BRANCHE,1,2,$LABELS);



drawInfo($im,$meanscale,$scale,$LEGEND,$INFOSMALL);

drawGraphArea($im,$BLACK);



imagepng ($im);
imagedestroy ($im);
?>

