<?php
//Bar-Graph FIXED for mulit-sets
$rootdir="../../";

//Settings importieren
$path="./" . $rootdir . "../" . substr(dirname($_SERVER['SCRIPT_NAME']),1) . "/" . $rootdir . "system/database/connect.inc.php";

include($path);
include("../settings/global.inc.php");

//settings
$LEFT_BORDER=50;
$RIGHT_BORDER=120;
$UPPER_BORDER=10;
$LOWER_BORDER=40;
$SIZE_X=600;
$SIZE_Y=320;

$FONT_SCALE['size']=1;
$FONT_LEGEND['size']=2;





//Bibliotheken nachladen
include("graph_functions.inc.php");

//Parameter auslesen...
foreach($_GET as $key => $value){

 if(substr($key,0,1)=="v"){
 $total[]=$value;
 }
 if(substr($key,0,1)=="s"){
 $scale[]=$value;
 }
 if(substr($key,0,2)=="mw"){
 $meanscale[]=$value;
 }
 if(substr($key,0,1)=="b"){
 $branche[]=$value;
 }
 if(substr($key,0,1)=="a"){
 $sbj_answer=$value;
 }
 if(substr($key,0,2)=="rt"){
 $sbj_answer_text=$value;
 }
 if(substr($key,0,2)=="ma"){
 $multi_answer[]=$value;
 }
 if(substr($key,0,2)=="nt"){
 $n_total=$value;
 }
 if(substr($key,0,2)=="nb"){
 $n_branche=$value;
 }
 if(substr($key,0,3)=="dmw"){
   if($value==0) $disp_mean=false;
   if($value==1) $disp_mean=true;
 }
 if(substr($key,0,5)=="lbl_t"){
 	$label_total=$value;
 }
 if(substr($key,0,5)=="lbl_b"){
 	$label_branche=$value;
 }
 if(substr($key,0,3)=="rss"){
  $subst_scale=true;
 }

}

$no_numbers=true;


//Gesamte Anzahlen ermitteln
if(is_array($abs_total)){
   foreach($abs_total as $key => $value){
   $anz_total+=$value;
   }
   $n_total=$anz_total;
   if($anz_total>0){
     foreach($abs_total as $key => $value){
     $total[]=$value/$anz_total*100;	
     }
   }
}

if(is_array($abs_branche)){
  foreach($abs_branche as $key => $value){
  $anz_branche+=$value;
  }
  $n_branche=$anz_branche;
  if($anz_branche>0){
    foreach($abs_branche as $key => $value){
    $branche[]=$value/$anz_branche*100;	
    }
   }
}

//Anzahl der Kategorien ermitteln, Breite der einzelnen Bereiche ermitteln
$num_category = count($total);

$spacing=($SIZE_X-$LEFT_BORDER-$RIGHT_BORDER)/($num_category);

//Maximale Skalenbeschriftung ermitteln und unteren Rand festlegen
 //Maximale String-Lnge ermitteln
 $max_value=0;
 $max_string="";
 foreach($scale as $skey => $svalue){
   if(strlen($svalue)>$max_length){
   	 $max_string=$svalue;
   	 $max_length=strlen($svalue);
   }
 }

 
header ("Content-type: image/png");
$im = @imagecreate ($SIZE_X, $SIZE_Y)
    or die ("Cannot Initialize new GD image stream");
    

include("../settings/phpgraph.inc.php");


$path_to_bgimg="./" . $rootdir . "../" . substr(dirname($_SERVER['SCRIPT_NAME']),1) . "/" . $rootdir . "custom/img/" . $BG_IMAGE;;


   $font_metrics=imagettfbbox($LABELS['size'],0,$LABELS['font'],"M");
   $font_height=abs($font_metrics[7]);
   $font_width=abs($font_metrics[2]);
   
  $max_chars=floor($spacing/$font_width);
  $dummy_text=wordwrap($max_string,$max_chars,"\n",1);
 //Anzahl der Zeilen:
 $rows=count(split("\n",$dummy_text));
   
  $font_metrics2=imagettfbbox($ANSWER['size'],0,$ANSWER['font'],"m");
  $max_chars=floor(($SIZE_X-$RIGHT_BORDER)/abs($font_metrics2[2]));
  $dummy_text=wordwrap($sbj_answer_text,$max_chars,"\n",1);
 //Anzahl der Zeilen:
 $rows2=count(split("\n",$dummy_text));
 
 $UPPER_BORDER=10+($rows2+1)*abs($font_metrics2[7]);
 $LOWER_BORDER=15+$rows*$font_height;

//Skalierung zeichnen
 //Maximalen Wert ermitteln
 $max_value=0;
 if(is_array($total)){
 foreach($total as $key => $value){
   if($value>$max_value) $max_value=$value;
 }
}
if(is_array($branche)){
  foreach($branche as $key => $value){
   if($value>$max_value) $max_value=$value;
 }
 }
 
 //Display-Hhe ermitteln
 $disp_height=$SIZE_Y-$UPPER_BORDER-$LOWER_BORDER;
 
 //Schrittweite ermitteln
  
 if($_GET['rst']=="prz"){
 //Prozentskalierung, Maximum ist 100%
   if($max_value%10<5){
     $steps_y=(($max_value-($max_value%10))/10)+2;
   }else{
     $steps_y=(($max_value-($max_value%10))/10)+3;
   }

   $stepping_y=floor($disp_height/$steps_y);
   $scale_height=($steps_y-1)*$stepping_y;
   $scale_sign="%";
   $scale_max=($steps_y-1)*10;
 }else{
   if($max_value%10<5){
     $steps_y=(($max_value-($max_value%10))/10)+2;
   }else{
     $steps_y=(($max_value-($max_value%10))/10)+3;
   }
   
   if($steps_y>=1000000) $steps_y=$steps_y/1000000;
   if($steps_y>=100000 && steps_y<1000000) $steps_y=$steps_y/100000;
   if($steps_y>=10000 && steps_y<100000) $steps_y=$steps_y/10000;
   if($steps_y>=1000 && steps_y<10000) $steps_y=$steps_y/1000;
   if($steps_y>=100 && steps_y<1000) $steps_y=$steps_y/100;
   if($steps_y>=10 && steps_y<100) $steps_y=$steps_y/10;
   
   $stepping_y=floor($disp_height/$steps_y);
   
   $stepping_y=10;
   
   $scale_height=($steps_y-1)*$stepping_y;
   $scale_sign="";
   $scale_max=($steps_y-1)*10;
   
   
   
 }

//Ab hier Zeichenfunktionen
//Antwort zeichnen falls vorhanden


if($sbj_answer!=0){
drawAnswer($im,$sbj_answer,$BAR_COLOR_ANSWER);	
}

drawBGImage($im,$path_to_bgimg);

//Legende zeichnen
drawLegend($im,$BLACK,$BAR_COLOR_TOTAL,$BAR_COLOR_BRANCHE,$BAR_COLOR_ANSWER,$LEGEND);
drawAnswerText($im,$sbj_answer_text,$ANSWER);

 //Skala zeichnen
 for($k=0;$k<$steps_y;$k++){
  //$font_height=imagefontheight(2);
  $font_metrics=imagettfbbox(10,0,$FONT_FACE,"TEST");
  $font_height=abs($font_metrics[7]);
  $pos_y=$SIZE_Y-$LOWER_BORDER-$k*$stepping_y+$font_height/2;
  

  imagettftext($im,$SKALA['size'],0,15,$pos_y, $SKALA['color'],$SKALA['font'],$k*10 . " %");
  drawHrzDotLine($im, $LEFT_BORDER, $SIZE_X-$RIGHT_BORDER, $SIZE_Y-$LOWER_BORDER-$k*$stepping_y, $SCALELINE); 
 }
 
if($disp_mean){
drawMean($im,$total,$meanscale,$BAR_COLOR_TOTAL);
if($ENABLE_BRANCH) drawMean($im,$branche,$meanscale,$BAR_COLOR_BRANCHE);
}


if(is_array($multi_answer)){
$cnt_bars=3;	
}else{
$cnt_bars=2;
}
if(!$ENABLE_BRANCH) $cnt_bars--;

if(is_array($total)){
drawBars($im,$total,$scale,$BAR_COLOR_TOTAL,0,$cnt_bars,$LABELS);
}
if(is_array($branche) && $ENABLE_BRANCH){
drawBars($im,$branche,$scale,$BAR_COLOR_BRANCHE,1,$cnt_bars,$LABELS);
}
if(is_array($multi_answer)){
drawBars($im,$multi_answer,$scale,$BAR_COLOR_ANSWER,2,$cnt_bars,$LABELS);
}

drawInfo($im,$meanscale,$scale,$LEGEND,$INFOSMALL);

drawGraphArea($im,$BLACK);



imagepng ($im);
imagedestroy ($im);
?>

