<?php
//EFL-Tracker 2003
//(c) E-Finance Lab, J. Franke 2003-2006, S.Martin 2006-2007

$rootdir="../";
$survey=true;

//Verbindung mit der Datenbank aufnehmen
include($rootdir . "system/database/connect.inc.php");

//Authentifizierung berprfen
include($rootdir . "system/authentication/authenticate.inc.php");

//Ersten Teil des Layouts nachladen
include($rootdir . "system/layout/header.inc.php");

if(!$authenticate){
include($rootdir . "system/authentication/auth_failure.inc.php");
}else{

?>
<link href="../system/css/efl-tracker.css" rel="stylesheet" type="text/css">



<table width="100%" border="0" cellspacing="2" cellpadding="2">
 <tr>         
  <td class="header1"> <p align="center" class="header1"><img src="../system/img/tracker_logo.gif" width="250" height="120"></p>
            
    <p align="center" class="header1"> <?php echo $STUDY_TITLE ?></p>
    <table width="500" border="0" align="center" cellpadding="0" cellspacing="0">
      <tr>
        <td>
          <p align="justify" class="stdtext">In vielen Branchen konnten in den 
            letzten Jahrzehnten bedeutende Produktivit&auml;tsfortschritte durch 
            die Vernetzung und damit tiefere Integration der am Produktionsprozess 
            Beteiligten erreicht werden. Ein prominentes Beispiel f&uuml;r erzielbare 
            Vernetzungs- und Kooperationsvorteile bietet die Automobilindustrie 
            einerseits mit ihren sprichw&ouml;rtlich integrierten Prozessen, also 
            dem Ausma&szlig; der automatisierten Zusammenarbeit der am Wertsch&ouml;pfungsprozess 
            Beteiligten, womit beispielsweise echtzeitige Fertigung und die Vermeidung 
            fehleranf&auml;lliger Medienbr&uuml;che und dadurch Kostenreduktionen 
            m&ouml;glich werden [<a href="literatur.php?session_ID=<?php echo $session_ID ?>">Sugimori et al. 1977</a>] 
            [<a href="literatur.php?session_ID=<?php echo $session_ID ?>">Waters-Fuller 1995</a>]. Andererseits ist 
            die Autobranche durch eine geringe Fertigungstiefe gekennzeichnet. 
            Dies impliziert ein starkes Ma&szlig; an Arbeitsteilung und Spezialisierung, 
            was signifikante Skalenertr&auml;ge und Lernkurven erm&ouml;glicht 
            [<a href="literatur.php?session_ID=<?php echo $session_ID ?>">Boyes/Melvin 1994</a>] [<a href="literatur.php?session_ID=<?php echo $session_ID ?>">Gravelle/Rees 
            1992</a>]. <br>
            <br>
            In Literatur wie Praxis hat sich f&uuml;r diese Denkrichtung der Begriff 
            Supply-Chain-Management (SCM) durchgesetzt. Supply-Chain-Management 
            beschreibt die Philosophie der integrierten Planung, Durchf&uuml;hrung 
            und Abwicklung einer Transaktion der G&uuml;ter- und Dienstleistungsproduktion. 
            Dabei steht eine Betrachtung der Prozessfl&uuml;sse, deren Senke letztlich 
            der Kunde ist, im Vordergrund und erweitert damit das traditionelle 
            Paradigma der potentialfaktorbasierten Engpassplanung um wertkettenweite 
            Prozessflussorientierung. SCM impliziert hierbei eine enge Abstimmung 
            der gegenseitig verbundenen G&uuml;ter-, Finanz- und Informationsfl&uuml;sse. 
            W&auml;hrend traditionelles SCM vor allem erfolgreich auf die Abstimmung 
            der G&uuml;ter- und Informationslogistik fokussiert [<a href="literatur.php?session_ID=<?php echo $session_ID ?>">St. 
            John/Heriot 1993</a>], l&auml;sst sich insbesondere bei Finanzprozessen, 
            die den Gegenstrom des G&uuml;terflusses darstellen, noch ungenutztes 
            Potential identifizieren und nutzen. <br>
            <br>
            Mit dem Ziel, einen Beitrag zur Industrialisierung in der Finanzwelt 
            zu leisten, wurde Anfang 2003 das <a href="http://www.efinancelab.de" target="_blank">E-Finance 
            Lab</a> von der <a href="http://www.uni-frankfurt.de" target="_blank">Universit&auml;t 
            Frankfurt am Main</a> und der <a href="http://www.tu-darmstadt.de" target="_blank">Technischen 
            Universit&auml;t Darmstadt</a> gemeinsam mit <a href="http://www.accenture.com" target="_blank">Accenture</a>, 
            <a href="http://www.deutsche-bank.com" target="_blank">Deutsche Bank</a>, 
            <a href="http://www.postbank.de" target="_blank">Deutsche Postbank</a>, 
            <a href="http://www.ibm.com" target="_blank">IBM</a>, <a href="http://www.microsoft.com">Microsoft</a>, 
            <a href="http://www.siemens.com" target="_blank">Siemens</a>, <a href="http://www.t-systems.de" target="_blank">T-Systems</a> 
            und <a href="http://www.isg.com" target="_blank">Innovative Software</a> 
            gegr&uuml;ndet. Unter der Leitung der Frankfurter Wirtschaftsprofessoren 
            Wolfgang K&ouml;nig, Bernd Skiera und Mark Wahrenburg sowie des Darmst&auml;dter 
            Informatik-Professors Ralf Steinmetz identifizieren f&uuml;nfzehn 
            Forscher Verbesserungspotenziale bei den traditionellen Wertsch&ouml;pfungsketten 
            der Finanzbranche sowie den Finanzprozessen von Unternehmen verschiedenster 
            Branchen. In diesem interdizplin&auml;ren Forschungsprojekt wird der 
            Einfluss der Informationstechnologie auf die Bankenwelt untersucht. 
            Der Begriff E-Finance verdeutlicht dabei, dass Innovationen in der 
            Finanzbranche &uuml;ber einen verst&auml;rkten Einsatz moderner, netzbasierter 
            Informations- und Kommunikationssysteme m&ouml;glich sind. Die Forscher 
            des E-Finance Lab sehen in der Prozessoptimierung der Financial-Services 
            entlang einer Supply-Chain physischer Produkte sowie im Straight-Through-Processing 
            innerhalb von und zwischen kooperierenden Finanzdienstleistern eine 
            vordringliche Zukunftsaufgabe in Forschung wie Praxis. <br>
            <br>
            Vor diesem Hintergrund f&uuml;hrte das E-Finance Lab eine ausf&uuml;hrliche 
            empirische Untersuchung mit den Finanzverantwortlichen der Top-1.000-Unternehmen 
            in Deutschland zu Verbesserungs- und Einsparpotenzialen bei Finanzprozessen 
            durch. Die vorliegende Studie verfolgt zwei Ziele: Zum einen sollen 
            Probleme und Verbesserungspotenziale in Finanzprozessen empirisch 
            erhoben werden. Hierzu werden ausgehend von einer idealtypischen Financial-Chain 
            das tats&auml;chliche Integrationsausma&szlig;, Kosten- und Nutzentreiber 
            bei Finanzprozessen sowie m&ouml;gliche Verbesserungsstrategien untersucht. 
            Zum anderen soll durch die Umfrage eine Grundlage f&uuml;r einen Beitrag 
            zur Industrialisierung in der Fi-nanzwelt gelegt werden, indem die 
            Ergebnisse als Vergleichsgrundlage einer Bewertung und Modellierung 
            der relevanten Prozesse in der Finanzbranche eingesetzt werden. Vor 
            diesem Hintergrund sind dies die thematischen Hauptgebiete der Studie:<br>
            <br>
            &#8226; Prozessoptimierung und Outsourcing bei Finanzprozessen<br>
            &nbsp;&nbsp;&nbsp;- Inner- und zwischenbetriebliche Integration<br>
            &nbsp;&nbsp;&nbsp;- IT-Kosten von Finanzprozessen<br>
            &nbsp;&nbsp;&nbsp;- Sourcingoptionen: B&uuml;ndelungs- und Outsourcingpotenzial<br>
            &nbsp;&nbsp;&nbsp;- Prozessoptimierungspotenziale<br>
            &nbsp;&nbsp;&nbsp;- Marktpartner und Marktchancen im Outsourcing<br>
            <br>
            &#8226; Effizienz der Teilprozesse der Financial-Chain<br>
            &nbsp;&nbsp;&nbsp;- Qualifikation, Preisstellung, Rechnung<br>
            &nbsp;&nbsp;&nbsp;- Reklamation<br>
            <br>
            &#8226; Visionen f&uuml;r Banken und Finanzdienstleister<br>
            <br>
            &#8226; Case-Studies bei Top-1.000-Unternehmen<br>
            <br>
            Ein Fragebogen mit 35 teils weiter detaillierten Fragen auf 8 Seiten 
            wurde an die Finanzverantwortlichen der umsatzst&auml;rksten 1.000 
            Unternehmen in Deutschland geschickt. Auch wenn die Studie nur einen 
            kleinen Ausschnitt des Forschungsgebietes der Prozessoptimierung abdecken 
            kann, stellt sie einen wichtigen Beitrag zum Verst&auml;ndnis und 
            der Einsch&auml;tzung von theoretisch wie praktisch relevanten Kostensenkungs- 
            und Erl&ouml;serschlie&szlig;ungspotenzialen bei Finanzprozessen dar. 
          </p>
          <p align="center" class="stdtext">Wir danken den <a href="partner.php?session_ID=<?php echo $session_ID ?>">Partnern</a> 
            des E-Finance Lab f&uuml;r ihre finanzielle und inhaltliche Unterst&uuml;tzung 
            der Studie.</p>
         <br><br>
          <table width="100%" border="0" cellspacing="0" cellpadding="0">
            <tr valign="top"> 
              <td class="stdtext"><div align="center">Prof. Dr. Wolfgang K&ouml;nig<br>
                  Dr. Tim Weitzel<br>
                  Dipl.-Kfm. Daniel Beimborn<br>
                  Dipl.-Kfm. Stefan Blumenberg<br>
                  Dipl.-Kfm. Jochen Franke <br>
                  <br>
                </div></td>
              <td class="stdtext"><div align="center">Prof. Dr. Bernd Skiera<br>
                  Dr. Sonja Gensler<br>
                  Dipl.-Kfm. Donovan Pfaff </div></td>
            </tr>
            <tr valign="top"> 
              <td class="stdtext"> <p align="center"><a href="http://www.is-frankfurt.de" target="_blank">Institut 
                  f&uuml;r Wirtschaftsinformatik</a><br>
                </p></td>
              <td class="stdtext"> <div align="center"><a href="http://ecommerce.wiwi.uni-frankfurt.de" target="_blank">Lehrstuhl 
                  f&uuml;r Electronic Commerce</a><br>
                </div></td>
            </tr>
          </table>
          
            </td>
      </tr>
    </table>
 
      <?php
include($rootdir . "system/layout/footer.inc.php");
}
?>